<script setup lang="ts">
    import { Article } from '@/logisticServiceOffer/entities/article/Article'
    import { Ref, ref, watch } from 'vue'
    import { CreateMouvementDto } from '../entities/mouvement/CreateMouvementDto'
    import { emitSnackBar } from '@/plugins/snackBarManager'
    import {
        assertDefined,
        isDefined,
        requiredInject,
    } from '@/shared/helpers/types'
    import { logisticServiceOfferInjectionKey } from '../constants'
    import { ArticleApi } from '../entities/article/ArticleApi'
    import { useMsal } from '@/plugins/msal/useMsal'
    import {
        LoadingManager,
        VolatileSecuredData,
    } from '@/shared/helpers/lifeCycle'
    import { useUserStore } from '@/shared/user/stores/UserStore'
    import {
        serviceOfferIdInjectionKey,
        serviceOfferTrackingCategoryInjectionKey,
    } from '@/shared/constants'
    import { RequestAborter } from '@/shared/api/entities/RequestAborter'
    import { SilabError } from '@/shared/errors/SilabError'
    import ArticleQuantitityForm from './ArticleQuantitityForm.vue'
    import { MouvementApi } from '../entities/mouvement/MouvementApi'
    import { getAnalyticsProvider } from '@/shared/analytics/AnalyticsProvider'
    import { Mouvement } from '../entities/mouvement/Mouvement'

    const logisticServiceOffer = requiredInject(
        logisticServiceOfferInjectionKey
    )

    const serviceOfferId = requiredInject(serviceOfferIdInjectionKey)

    const msal = useMsal()
    const userStore = useUserStore(msal)
    interface Props {
        articleCode: Article['code']
        typeDeMouvementId: string
    }

    const props = defineProps<Props>()
    const emit =
        defineEmits<(e: 'mouvementCréé', mouvement: Mouvement) => void>()

    const article: Ref<VolatileSecuredData<Article>> = ref(undefined)
    const articleApi = new ArticleApi(msal)
    const articleAbortController: RequestAborter = new RequestAborter()
    watch(
        [
            serviceOfferId,
            () => props.articleCode,
            () => {
                return userStore.currentUserHasRoleForServiceOffer(
                    'LOGISTIQUE_CONSULTER_ARTICLES',
                    serviceOfferId.value
                )
            },
        ],
        () => {
            article.value = undefined
            articleAbortController.abortRequestsAndRefreshAborter()
            if (
                !userStore.currentUserHasRoleForServiceOffer(
                    //amélioration: piste->composable du type useCurrentUserRight(right, serviceOfferId)
                    'LOGISTIQUE_CONSULTER_ARTICLES', //Amelioration, on devrait peut-être vérifier les droits au niveau de l'api front plutot, ce serait plus pratique, et elle nous renverrai du secureddata directement :D
                    serviceOfferId.value
                )
            ) {
                article.value = {
                    accessGranted: false,
                    data: undefined,
                }
                return
            }
            articleApi
                .getByCode(
                    serviceOfferId.value,
                    props.articleCode,
                    articleAbortController.getSignal()
                )
                .then((fetchedArticle) => {
                    article.value = {
                        accessGranted: true,
                        data: fetchedArticle,
                    }
                })
                .catch((error) => {
                    if (error.name !== 'AbortError') {
                        throw new SilabError(
                            `Erreur lors de la récupération des diagnostiques`,
                            error
                        )
                    }
                })
        },
        { immediate: true }
    )

    const mouvementLoadingManager: LoadingManager = new LoadingManager()

    const mouvementApi = new MouvementApi(msal)
    const serviceOfferTrackingCategory = requiredInject(
        serviceOfferTrackingCategoryInjectionKey
    )
    async function créerMouvementInventaire(
        mouvementInventaire: CreateMouvementDto
    ) {
        assertDefined(article.value?.data)
        const ancienneQuantité = article.value.data.lots.find((lot) => {
            return lot.emplacement?.id === mouvementInventaire.emplacement?.id
        })?.quantité as number
        const nouvelleQuantité = ancienneQuantité + mouvementInventaire.quantité
        const stopLoading = mouvementLoadingManager.startLoading()
        try {
            const mouvementCréé = await mouvementApi.create(
                serviceOfferId.value,
                mouvementInventaire
            )

            assertDefined(article.value?.data)
            getAnalyticsProvider().sendEvent(
                serviceOfferTrackingCategory.value,
                "Mouvement d'inventaire",
                `${article.value.data.code} : ${article.value.data.titre}`,
                mouvementCréé.quantité
            )

            emitSnackBar(
                `${nouvelleQuantité} ${article.value.data.unité.toLowerCase()} enregistré pour l'article ${
                    article.value.data.code
                }, ancienne quantité ${ancienneQuantité} ${article.value.data.unité.toLowerCase()}.`,
                'primary'
            )
            emit('mouvementCréé', mouvementCréé)
        } catch (error) {
            throw new SilabError(
                "Echec de création du mouvement d'inventaire",
                error
            )
        } finally {
            stopLoading()
        }
    }
</script>

<template>
    <div
        v-if="isDefined(article?.data) && isDefined(logisticServiceOffer)"
        v-bind="$attrs"
    >
        <!-- Amelioration: :type-de-mouvement-id="logisticServiceOffer.typeDInventaireId" , ça devrait plutot être ponctuel systématiquement, mais bon faut faire d'autre modif si on fait ça  -->
        <article-quantitity-form
            v-for="lot in article.data.lots"
            :key="
                article.data.code +
                '-' +
                (lot.emplacement?.code ? lot.emplacement.code : '')
            "
            class="mb-3"
            :is-processing="mouvementLoadingManager.isLoading.value"
            :type-de-mouvement-id="logisticServiceOffer.typeDInventaireId"
            :article="article.data"
            :lot-initial="lot"
            submit-label="Valider et continuer"
            @submit="
                (mouvement) => {
                    créerMouvementInventaire(mouvement)
                }
            "
        />
    </div>
    <VSkeletonLoader v-else type="card" />
</template>
